#include <assert.h>
#include <stdio.h>
#include <stdlib.h>

#include "bignum.h"
#include "util.h"

int
bnum_copy(struct bignum *dst, const struct bignum *src)
{
	int i, ok;

	assert(dst != NULL && src != NULL);
	
	dst->sign = src->sign;
	dst->top = src->top;

	ok = bnum_ensure_len(dst, src->top+1);

	if (!ok)
		return BIGNUM_NOMEM;

	for (i = 0; i <= src->top; i++)
		dst->val[i] = src->val[i];

	return BIGNUM_OK;
}

